{
 Error stuff ;-)

 (c) 1999-2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]
     [ made on the basis of raVen's (2:5010/150.16) Error unit and
       V.V.Faronov's book ;-) ]

 history:
 ~~~~~~~
 [07/03/00] - Unit fixed. Now you can use it without problems.
}
{$F+}
{&D+,H-,L+,LocInfo+}
unit Dp_Error;

interface

implementation

uses
  Dp_Basis, Dp_Comn;

var
  ExitAddress: Pointer;

{ͻ}
procedure ErrorExit;
var
  S, St: String;
  Line: Longint;
begin
  if ErrorAddr <> nil then
  begin
    PrintStr('Error number '+LPadCh(N2Str(ExitCode), '0', 3));
    {$IfDef VirtualPascal}
    if GetLocationInfo(ErrorAddr, S, Line) <> nil then
      PrintlnStr(' in '+S+', line '+N2FmtStr(Line))
    else
    {$EndIf}
    PrintlnStr(' at '+HexL(Longint(ErrorAddr)));

    case ExitCode of
      1..18     : St := 'DOS ERROR: ';
      100..106  : St := 'I/O ERROR: ';
      150..162,
      200..216  : St := 'CRITICAL ERROR: ';
      else        Exit;
    end;

    case ExitCode of
      001: S := 'Invalid function number.';
      002: S := 'File not found.';
      003: S := 'Path not found.';
      004: S := 'Too many open files.';
      005: S := 'File access denied.';
      006: S := 'Invalid file handle.';
      012: S := 'Invalid file access code.';
      015: S := 'Invalid drive number.';
      016: S := 'Cannot remove current directory.';
      017: S := 'Cannot rename across drives.';
      018: S := 'No more files.';
      100: S := 'Disk read error.';
      101: S := 'Disk write error.';
      102: S := 'File not assigned.';
      103: S := 'File not open.';
      104: S := 'File not open for input.';
      105: S := 'File not open for output.';
      106: S := 'Invalid numeric format.';
      150: S := 'Disk is write-protected.';
      151: S := 'Unknown unit.';
      152: S := 'Drive not ready.';
      153: S := 'Unknown command.';
      154: S := 'CRC error in data.';
      155: S := 'Bad drive request structure length.';
      156: S := 'Disk seek error.';
      157: S := 'Unknown media type.';
      158: S := 'Sector not found.';
      159: S := 'Printer out of paper.';
      160: S := 'Device write fault.';
      161: S := 'Device read fault.';
      162: S := 'Hardware failure.';
      200: S := 'Division by zero.';
      201: S := 'Range check error.';
      202: S := 'Stack overflow error.';
      203: S := 'Heap overflow error.';
      204: S := 'Invalid pointer operation.';
      205: S := 'Floating point overflow.';
      206: S := 'Floating point underflow.';
      207: S := 'Invalid floating point operation.';
      208: S := 'Overlay manager not installed.';
      209: S := 'Overlay file read error.';
      210: S := 'Object not initialized.';
      211: S := 'Call to abstract method.';
      212: S := 'Stream registration error.';
      213: S := 'Collection index out of range.';
      214: S := 'Collection overflow error.';
      215: S := 'Arithmetic overflow error.';
      216: S := 'General Protection fault.';
      else S := 'Unknown Error.';
    end;

    PrintlnStr(Concat(St, S));
    ErrorAddr := nil;
  end;

  ExitProc  := ExitAddress;
end;
{ͼ}

begin
  ExitAddress := ExitProc;
  ExitProc    := @ErrorExit;
end.
