{
 Memory leak counter

 (c) by sergey korowkin [sk], 2:6033/27
 (c) 2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]
}
unit Leaker;

interface

uses
  Dp_Comn {$IFDEF VIRTUALPASCAL}, vpUtils {$ENDIF};

var
  MemoryLeak: Longint;

{}
procedure LeakFix(var Storage: Longint);
procedure LeakCount(var Storage: Longint);
{}
function  LeakStr: String;
{}

{}
{}
{}

implementation

var
  Counted: Boolean;

{}
procedure LeakFix(var Storage: Longint);
begin
  Storage := {$IFDEF VIRTUALPASCAL} MemUsed {$ELSE} MemAvail {$ENDIF};
  Counted := False;
end;
{}
procedure LeakCount(var Storage: Longint);
begin
 {$IFDEF VIRTUALPASCAL}
  Storage := MemUsed - Storage;
 {$ELSE}
  Dec(Storage, MemAvail);
 {$ENDIF}
  Counted := True;
end;
{}
function LeakStr: String;
begin
  if not Counted then LeakCount(MemoryLeak);
  LeakStr := N2FmtStr(MemoryLeak);
end;
{}

begin
  LeakFix(MemoryLeak);
end.
