{
 XLat stuff (only CP866 and CP1251 yet)

 (c) 2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]

 history:
 ~~~~~~~
 [27/03/00] - First version
              Thanx to Ruslan Brychljaev [2:5023/34] for recode tables
}
{&LocInfo+}
{$B-,D+,L+,R-,V-}
Unit Dp_XLat;

interface

uses
  Dp_Basis;

type
  XLatTable = array[128..255] of Byte;

const
  D2WTable : XLatTable =
    ($C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF,
     $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF,
     $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,
     $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,
     $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,
     $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,
     $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF,
     $A8,$B8,$AA,$BA,$AF,$BF,$A1,$A2,$B0,$95,$B7,$FB,$B9,$A4,$FE,$FF);

  W2DTable : XLatTable =
    ($20,$20,$2C,$20,$20,$20,$20,$20,$20,$20,$20,$3C,$20,$20,$20,$20,
     $20,$20,$27,$20,$22,$F9,$2D,$2D,$20,$20,$20,$3E,$20,$20,$20,$20,
     $20,$F6,$F7,$20,$FD,$20,$20,$15,$F0,$20,$F2,$20,$20,$20,$20,$F4,
     $F8,$20,$B3,$69,$20,$20,$14,$FA,$F1,$FC,$F3,$20,$20,$20,$20,$F5,
     $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F,
     $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F,
     $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,
     $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF);

{}
function StrDos2Win(const S: String): String;
function StrWin2Dos(const S: String): String;
{}

{}
{}
{}

implementation

{ͻ}
function StrDos2Win(const S: String): String;
var
  i: xByte;
begin
  for i := 1 to Length(S) do
    if Byte(S[i]) in [128..255] then
      StrDos2Win[i] := Char(D2WTable[Byte(S[i])]);

 {$IfDef VirtualPascal}
  SetLength(Result, Length(S));
 {$Else}
  StrDos2Win[0] := S[0];
 {$EndIf}
end;
{}
function StrWin2Dos(const S: String): String;
var
  i: xByte;
begin
  for i := 1 to Length(S) do
    if Byte(S[i]) in [128..255] then
      StrWin2Dos[i] := Char(W2DTable[Byte(S[i])]);

 {$IfDef VirtualPascal}
  SetLength(Result, Length(S));
 {$Else}
  StrWin2Dos[0] := S[0];
 {$EndIf}
end;
{ͼ}

end.
